package edu.laura.temaValaszt.jdbc;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.LinkedList;
import java.util.List;

import edu.laura.temaValaszt.beans.StudentBean;
import edu.laura.temaValaszt.dao.StudentDAO;

public class StudentDAOJDBC implements StudentDAO {
	
	/**
	 * @param userName
	 * @param password
	 */
	public StudentBean getPersonByUserNameAndPassword(String userName, String password) {
		return getStudentBean("SELECT * FROM student WHERE username='" +
	    		userName +"' AND passwd='"+password+"'");
	}
	
	public List<StudentBean> getPersonsWithProject() {
		return getStudentBeanList("SELECT * FROM student s, studenttoproject sp " +
				"WHERE s.ObjectID=sp.StudentID;");
	}
	
	private static StudentBean getStudentBean(String selectStatement) {
		Connection connection = JDBCDataSource.getConnection();
		Statement statement=null;
		StudentBean studentBean=null;
		ResultSet resultSet=null;
		try {
			statement = connection.createStatement();
			resultSet = statement.executeQuery(selectStatement);
		    if(resultSet.next()){
		    	studentBean = getStudentBeanFromResultSetRecord(resultSet);
		    }
		} catch (SQLException e) {
			e.printStackTrace();
		}
		finally {
			try {
				resultSet.close();
			} catch (Exception e) {
				// handle exception
				// pl. lehet log-ot irni...
			}
			try {
				statement.close();
			} catch (Exception e) {
			}
			try {
			    connection.close();
			} catch (Exception e) {
			}
		}
	    return studentBean;
	}
	
	private static List<StudentBean> getStudentBeanList(String selectStatement) {
		Connection connection = JDBCDataSource.getConnection();
		Statement statement;
		List<StudentBean> list=new LinkedList<StudentBean>();
		try {
			statement = connection.createStatement();
			ResultSet resultSet = statement.executeQuery(selectStatement);
			while (resultSet.next()) {
				list.add(getStudentBeanFromResultSetRecord(resultSet));
			}
			resultSet.close();
			statement.close();
		} catch (SQLException e) {
			e.printStackTrace();
		}
		finally {
			try {
				connection.close();
			} catch (SQLException e) {
				e.printStackTrace();
			}
		}
		return list;
	}
	
	private static StudentBean getStudentBeanFromResultSetRecord(ResultSet resultSet) throws SQLException {
		StudentBean studentBean = new StudentBean() ;
		studentBean.setObjectID(Integer.valueOf(resultSet.getInt("ObjectID")));
    	studentBean.setUserName(resultSet.getString("UserName"));
    	studentBean.setLastName(resultSet.getString("LastName"));
    	studentBean.setFirstName(resultSet.getString("FirstName"));
		return studentBean;
	}
}
