package edu.laura.temaValaszt.jdbc;


import edu.laura.temaValaszt.dao.DAOFactory;
import edu.laura.temaValaszt.dao.ProjectDAO;
import edu.laura.temaValaszt.dao.StudentDAO;
import edu.laura.temaValaszt.dao.StudentToProjectDAO;

public  class JDBCDAOFactory extends DAOFactory {
	
	public ProjectDAO getProjectDAO() {
		return new ProjectDAOJDBC();
	}
	public StudentDAO getStudentDAO() {
		return new StudentDAOJDBC();
	}
	public StudentToProjectDAO getStudentToProjectDAO() {
		return new StudentToProjectDAOJDBC();
	}
}
